!src "config.inc"
!cpu 6510

.debugcode	= $0108

.VIA2_LED_OFF	= $f7
.VIA2_LED_ON	= $08

.VIA2_MOTOR_OFF	= $fb
.VIA2_MOTOR_ON	= $04

.bin2ser	= $20		;binary to serial data

.directory	= $0500		;directory
.lonibbles	= $0600
.hinibbles	= $0700

bitfire_fetch_ram
                ldy #$00
-
                lda .debug_start,y
                jsr bitfire_send_byte_
                iny
		cpy #.debug_size
                bne -

		lda #$00
		sta bitfire_load_addr_lo
		lda #$20
		sta bitfire_load_addr_lo + 1
-
		lda $dd00
		anc #$c0
		bne -

		jsr bitfire_set_atn_
		jsr bitfire_reset_atn_

		lda #$00
		jmp bitfire_load_block

.debug_start
		!byte $80,<.debug_run,>.debug_run,<.debug_last,>.debug_last
!pseudopc .debugcode {
.debug_run
		ldy #$00
-
		lax .directory,y
		and #$0f
		sta .lonibbles,y
		txa
		lsr
		lsr
		lsr
		lsr
		sta .hinibbles,y
		iny
		bne -
.send_block
		;send 2 or 4 bytes of blockinfo as preamble
		ldy #$00

		;signal that a block is ready
		lda #BLOCK_READY | BUSY		;DATA_OUT
		sta $1800

		;wait for response of host
		bit $1800
		bpl *-3
		;on atn going low we have alraedy first data on bus with the upcoming code

		ldy #$ff
		;send the data block
		ldx .lonibbles,y
.sendloop
		;this loop is much tighter then the preamble, no cycles to be wasted
		lda .bin2ser,x
		bit $1800
		bmi *-3
		sta $1800

		asl
		ora #$10
		ldx .hinibbles,y
		bit $1800
		bpl *-3
		sta $1800

		lda .bin2ser,x
		dey
		;nop
		bit $1800
		bmi *-3
		sta $1800

		asl
		ora #$10
		ldx .lonibbles,y
		bit $1800
		bpl *-3
		sta $1800
		cpy #$ff
		bne .sendloop

		bit $1800
		bmi *-3

		lda #BUSY
		sta $1800

		jmp *
.debug_last
}
.debug_end

.debug_size = .debug_end - .debug_start
