!zone resident {
!src "../music.inc"
!src "config.inc"
!convtab pet
!cpu 6510

;XXX TODO could be saved, 3 bytes overhead for SMC needed then
;loader zp-addresses
.readblock	= BITFIRE_ZP_ADDR + 0
.filenum	= .readblock

;depacker zp-addresses
.lz_bits	= BITFIRE_ZP_ADDR + 1
.lz_dst		= BITFIRE_ZP_ADDR + 2

;define that label here, to not collect labels from installer too
bitfire_install_ = BITFIRE_INSTALLER_ADDR

!if BITFIRE_INCLUDE_DECOMP = 0 {
bitfire_load_addr_hi = .filenum			;in case of no loadcompd, store the highbyte of loadaddress separatedly
	;check sanity of config
	!if BITFIRE_INCLUDE_FRAMEWORK = 1 {
		!error "Cant't include FRAMEWORK without DECOMP."
	}
}

		* = BITFIRE_RESIDENT_ADDR

link_chip_types
link_cia_type
link_sid_type
		!byte $00

!if BITFIRE_NMI_GAPS = 1 {
		nop
		nop
		nop
		nop
		nop
		nop
		nop
}

!if BITFIRE_INCLUDE_FRAMEWORK = 1 {
link_player
		pha
		txa
		pha
		tya
		pha
		inc $01			;should be save with $01 == $34/$35, except when music is @ >= $e000
		dec $d019
link_music_addr = * + 1
		jsr link_music_play_side1
		dec $01
		pla
		tay
		pla
		tax
		pla
		rti

;		;expect $01 to be $35
;link_load_next_double
;		;loads a splitted file, first part up to $d000 second part under IO
;		jsr link_load_next_comp
;link_load_next_raw_decomp
;		jsr link_load_next_raw
;		dec $01			;bank out IO
;		jsr link_decomp		;depack
;		inc $01			;bank in again
;		rts
;
}

bitfire_send_byte_
		;jsr bitfire_set_atn_		;lines are always free when floppy is idle, no need to set lines
		sec				;insert bit as counter
		ror				;fetch first bit and set marker bit
		sta .filenum			;save value
		ldx #$3f			;start value, is also our mask
		txa
.bit_loop
		and #$2f			;clear bit 4
		adc #$20			;toggle bit 5 and set bit 4 depending on carry -> adc #$20/21
		ora #$0f			;set all lower bits again for next round

		sax $dd02			;only write out lower 6 bits
!if BITFIRE_INCLUDE_DECOMP = 1 {
		lsr .seq_max_block		;clear barrier position and waste cylces
} else {
		nop
}
		lsr <(.filenum-$3f),x		;fetch next bit from filenumber and waste cycles
		bne .bit_loop			;last bit?
		stx $dd02			;all lines low again
		rts

!if BITFIRE_INCLUDE_FRAMEWORK = 1 {
link_load_next_raw
		lda #BITFIRE_LOAD_NEXT
link_load_raw
}

bitfire_loadraw_
		jsr bitfire_send_byte_		;easy, open...
!if BITFIRE_INCLUDE_DECOMP = 1 {
-
		jsr .pollblock
		bcc -
.ret
		rts
}
.pollblock
		lda $dd00
		anc #$c0			;focus on bit 7 and 6 and copy bit 7 to carry (set if floppy is idle/eof is reached)

!if BITFIRE_INCLUDE_DECOMP = 1 {
		bne .ret			;only fetch block if both bits are 0 (floppy !idle + block_ready)
		txa				;save x, but only if loadcompd is in use
		pha
} else {
		bne .poll_end			;if loadraw only is enabled, skip the blockfetch part and loop
}
		lda #$60			;set rts
		jsr bitfire_ack_		;signal that we accept data and communication direction, by basically sending 2 atn strobes by fetching a bogus byte (6 bits could also be used for status? (first two bits might be broken))

		beq .skip_load_addr

		jsr .get_one_byte_no + 2	;fetch loadaddr hi
		sta bitfire_load_addr_hi
!if BITFIRE_INCLUDE_DECOMP = 1 {		;decompressor only needs to be setup if there
		;sta bitfire_lz_sector_ptr1 + 1
		sta bitfire_lz_sector_ptr2 + 1
		sta bitfire_lz_sector_ptr3 + 1
}
		jsr .get_one_byte_no + 2	;fetch blockaddr lo
!if BITFIRE_INCLUDE_DECOMP = 1 {		;decompressor only needs to be setup if there
		sta bitfire_lz_sector_ptr1	;set initial pointers
		sta bitfire_lz_sector_ptr2
		sta bitfire_lz_sector_ptr3
}
		sta bitfire_load_addr_lo	;destination lowbyte
		sta bitfire_load_addr_lo2	;destination lowbyte
.skip_load_addr
		jsr .get_one_byte_no + 2	;fetch blockaddr hi
		cmp #$d0
		bcc +
		cmp #$e0
		bcs +
		sta .bitfire_block_addr_hi2	;need to save load_addr_hi seperatedly, as the sector_ptr* will be incremented and thus can't be used as load_addr, most of all if we want to reuse the load_addr after loading
		ldx #$90			;bcc .io_safe
		ldy #(.io_safe-.io_en)
		bne ++
+
		ldx #$99			;restore opcode
		ldy bitfire_load_addr_lo2	;restore lobyte
		sta .bitfire_block_addr_hi	;need to save load_addr_hi seperatedly, as the sector_ptr* will be incremented and thus can't be used as load_addr, most of all if we want to reuse the load_addr after loading
++
		stx .io_en
		sty .io_en+1
						;XXX TODO would be sufficient to signal if current index shall be new barrier
!if BITFIRE_INCLUDE_DECOMP = 1 {
		jsr .get_one_byte_no
		sta .seq_max_block		;next barrier position
}

		jsr .get_one_byte_no + 2	;fetch blocklen - switch already set to rts, but need to set x again
bitfire_load_block
		tay
		lda #$a0			;ldy #imm
bitfire_ack_
		sta .blockpos
.get_one_byte_no
		ldx #$37
.getloop
bitfire_ntsc_fix1				;ntsc fix will be done on those labels by installer (opcode $xxxx-$37,x)
		lda $dd00
		stx $dd02
		lsr
		lsr
		sty .blockpos+1			;store initial y, and in further rounds do bogus writes with correct y value anyway, need to waste 4 cycles, so doesn't matter. Saves a byte (tay + sty .blockpos+1) copared to sta .blockpos+1 + nop + nop.
		ldy #$3f

bitfire_ntsc_fix2
		ora $dd00
		sty $dd02
		lsr
		lsr
		dec .blockpos+1			;waste 6 cycles and decrement

bitfire_ntsc_fix3
		ora $dd00			;now ATN is 0 and ora can happen without killing bit 3
		stx $dd02
		lsr
		asr #$7e			;clear carry for free
		sta .nibble + 1
		lda #$c0

bitfire_ntsc_fix4
		and $dd00
		sty $dd02
.nibble		ora #$00			;also adc could be used, or sbc -nibble?
.blockpos	ldy #$00
.bitfire_block_addr_hi = * + 2
bitfire_load_addr_lo = * + 1
.io_en
		sta $beef,y
		bne .getloop			;74 cycles per loop

.getend
!if >* != >.getloop = 1 { !error "getloop code crosses page!" }
!if BITFIRE_INCLUDE_DECOMP = 1 {
		pla
		tax				;restore x
		rts				;XXX TODO, could be omitted, following code would not hurt if run
.io_safe
		inc $d020
		jmp *-3
		dec $01
.bitfire_block_addr_hi2 = * + 2
bitfire_load_addr_lo2 = * + 1
		sta $beef,y
		inc $01
		tya
		bne .getloop
		beq .getend			;XXX TODO, could be omitted, following code would not hurt if run
} else {
.poll_end
		bcc .pollblock
		rts				;XXX TODO, could be omitted, following code would not hurt if run
}

!if BITFIRE_INCLUDE_DECOMP = 1 {
;---------------------------------------------------------------------------------
; REFILL ROUTINES
;---------------------------------------------------------------------------------

.lz_refill_bits
bitfire_lz_sector_ptr1	= * + 1
bitfire_load_addr_hi = * + 2
		ldy $beef,x
		sty .lz_bits
		rol .lz_bits
		inx
		bne .lz_same_page

.lz_next_page					;XXX things entered here as well during depacking
		inc bitfire_lz_sector_ptr1 + 1
		inc bitfire_lz_sector_ptr2 + 1
		inc bitfire_lz_sector_ptr3 + 1

		php
		pha
		tya
		pha
.lz_skip_fetch	jsr .lz_fetch_sector
		pla				;restore regs + flags
		tay
		pla
		plp
.lz_same_page
		rts

.lz_fetch_sector				;entry of loop
		lda #$35
		sta $01
.lz_fetch_loop
		jsr .pollblock			;fetch another block, leaves x untouched
		bcs .lz_fetch_eof		;eof? yes, finish
		lda .readblock			;processed blocks
.seq_max_block = * + 1
		cmp #$00			;next pending block/barrier
		bcs .lz_fetch_loop		;same or below
		inc .readblock			;bump blockcounter
.lz_fetch_eof
		php
		lda bitfire_lz_sector_ptr1 + 1
		cmp #$d0
		bcc +
		cmp #$e0
		bcs +
		dec $01
+
		plp
.lz_end_of_file
		rts

!if BITFIRE_NMI_GAPS = 1 {
!align 255,0
		nop
		nop
		nop
		nop
		nop
}
!if BITFIRE_INCLUDE_FRAMEWORK = 1 {
link_load_next_comp
		lda #BITFIRE_LOAD_NEXT
link_load_comp
}
bitfire_loadcomp_
		jsr bitfire_send_byte_
		;lda #$00
		;sta .readblock			;start with readpos = 0 -> is always zero as it is shifted empty on opening file
		lda #$20			;enable pollblock/fetch_sector calls
		ldx #$ff			;force to load a new sector upon second read, first read is a bogus read and will be stored on lz_bits
		bne .loadcompd_entry
bitfire_decomp_
link_decomp
		lda #$2c			;disable calls
		ldx #$00			;start with first byte of block
.loadcompd_entry
		sta .lz_skip_fetch
		sta .lz_skip_poll
		;load_addr is already set by loadraw_/pollblock

;---------------------------------------------------------------------------------
; DECRUNCHER
;---------------------------------------------------------------------------------


		;******** Start the next match/literal run ********
.lz_decrunch
-
		jsr .lz_refill_bits		;fetch depack addr
		sty .lz_dst-1,x			;x = 0, x = 1 and x = 2
		cpx #$02
		bne -


		;sec				;This is the main entry point. Forcibly
.lz_type_refill	jsr .lz_refill_bits		;fill up the the bit buffer on entry
.lz_type_check
		bcc .lz_do_match
		beq .lz_type_refill		;We will fall through on entry

		;******** Process literal run ********

		lda #$00
-
		rol				;-> a = $01 after first round
		asl .lz_bits
		bne *+5
		jsr .lz_refill_bits		;kills y
		bcc .lz_lrun_gotten

		asl .lz_bits
		bne -
		jsr .lz_refill_bits
		bne -

						;XXX code can be inserted here
.lz_lrun_gotten
		sta .lz_lcopy_len		;Store LSB of run-length
		ldy #$00
.lz_lcopy
bitfire_lz_sector_ptr2	= * + 1			;Copy the literal data.
		lda $beef,x
		sta (.lz_dst),y
		inx
		bne *+5
		jsr .lz_next_page
		iny
.lz_lcopy_len = * + 1
		cpy #$00
		bne .lz_lcopy

		;Time to advance the destination pointer.
		;Maximum run length literals exit here as a type-bit needs
		;to be fetched afterwards
		tya
		beq .lz_maximum			;maximum literal run, bump sector pointers and so on and force new type bit
		clc
		adc .lz_dst
		sta .lz_dst
		bcc *+4
		inc .lz_dst+1

		;One literal run following another only makes sense if the
		;first run is of maximum length and had to be split. As that
		;case has been taken care of we can safely omit the type bit
		;here


		;******** Process match ********

		;check bit -> 1 -> short match (len 2)
		;else long match

.lz_do_match
		lda #$01			;this could be made shorter by using the last bitfetch of the upcoming loop and restoring the carry again by a cmp #$02. Saves bytes, but makes things slower, as eof check is also done with all short matches then

		asl .lz_bits			;first length bit (where a one identifies
		bne *+5				;a two-byte match)
		jsr .lz_refill_bits
		bcc .lz_get_offs		;all done, length is 2, skip further bitfetches (and eof check)
-
		asl .lz_bits
		bne *+5
		jsr .lz_refill_bits
		rol

		asl .lz_bits
		bne *+5
		jsr .lz_refill_bits
		bcc -

		tay				;XXX TODO could this be placed elsewhere to make the tay obsolete?
		beq .lz_end_of_file		;A 257-byte (=>$00) run serves as a
						;sentinel
.lz_get_offs
		sta .lz_mcopy_len	;store length at final destination
		lda #%11000000		;fetch 2 more prefix bits
		rol			;previous bit is still in carry \o/
-
		asl .lz_bits
		bne *+5
		jsr .lz_refill_bits
		rol
		bcs -

		beq .lz_far			;0 + 8 bits to fetch, branch out before table lookup to save a few cycles and one byte in the table
		tay
		lda .lz_lentab,y
-
		asl .lz_bits
		bne *+5
		jsr .lz_refill_bits
		rol
		bcs -
		bmi .lz_short		;either 3,4,6 or 7 bits fetched -> highbyte will be $ff
.lz_far
		eor #$ff		;7 of 15, 4 of 12 bits fetched as highbyte, lowbyte still to be fetched
		tay

bitfire_lz_sector_ptr3	= * + 1
		lda $beef,x			;For large offsets we can load the
		inx				;low-byte straight from the stream
		bne .lz_join			;without going throught the shift
		jsr .lz_next_page		;register
		top
.lz_short
		ldy #$ff		;XXX TODO silly, y is set twice in short case
.lz_join
		adc .lz_dst			;subtract offset from lz_dst
		sta .lz_m_+1
		tya			;hibyte
		adc .lz_dst+1
		sta .lz_m_+2

		ldy #$ff			;The copy loop. This needs to be run
						;forwards since RLE-style matches can overlap the destination
.lz_mcopy
		iny
.lz_m_
		lda $beef,y			;Copy one byte
		sta (.lz_dst),y
.lz_mcopy_len	= * + 1
		cpy #$ff
		bne .lz_mcopy

		tya				;Advance destination pointer
;		sec
		adc .lz_dst
		sta .lz_dst
		bcc *+4
.lz_maximum	inc .lz_dst+1			;This is also used by maximum length

.lz_skip_poll
		jsr .lz_fetch_sector		;yes, fetch another block and mark block in bitmap
						;literals needing an explicit type bit
		asl .lz_bits			;Fetch next type bit
		jmp .lz_type_check
						;XXX TODO swap short/far cases -> += 1 byte but faster

		;******** Fetch some more bits to work with ********

.lz_lentab = * - 1
		;short offset init values
		;!byte %00000000			;2
		!byte %11011111			;0
		!byte %11111011			;1
		!byte %10000000			;3

		;long offset init values
		!byte %11111101			;offset 1
		!byte %11101111			;offset 0
		!byte %11110000			;offset 3
		!byte %10000000			;offset 2

}	;endif DECOMP

}	;!zone resident


;XXX TODO IO Safe
;before fetching block, set $01 to $35
;then do dec/inc $01 in case of $d000-$dfff
